#include "my.h"
#include "label.h"

#ifdef MODULE

#include "mylib.c"
void UpdateScreen(void);
static _CPUReg RR;
static _CPUReg RegOld;
#else
byte RAM[65536]={0xdd,0x77,0xcf,0xcd,0x00,0x00,0xcb,0x37,0xed,0x7b,1,0,0xed,0xb0,0x38,0,0xed,0x4b,0xc3,0,0,0xcb,0xff,4,5,6,7,8,9,10,11,12,13,14,15};
extern  _CPUReg RR;
extern  _CPUReg RegOld;
#endif



word AddrLIST=0;
word AddrDUMP=0;

int MODE=0;
int TraceCPU=0;

char *tMODE[]={//1234567
                  " List  ",
                  " Dump  ",
                  " Regs  ",
                  " Esc   ",
                };

int CBorder=0x2;
int CBreak =0x7;
int CList  =0x7;
int CList1 =0x2f;
int CList2 =0x30;
int CMode  =0xf;
int CRegs  =0x7;
int CRegs2 =0x7;
int CRegs3 =0xb;
int CDump  =0x7;
int CDump1 =0x2f;
int CHelp  =0x2;
int CText  =0x7;


byte AIF(byte c)        // AsciiFilter
{
 if (c<' ') c='';
 return c;
}

byte RdZ80(word addr)
{
#ifdef MODULE
  return  (TblData->SpecSeg[addr>>0xE])[addr&0x3FFF];
#else
  return RAM[addr];
#endif
}

void WrZ80(word addr,byte b)
{
#ifdef MODULE
  (TblData->SpecSeg[addr>>0xE])[addr&0x3FFF]=b;
#else
  RAM[addr]=b;
#endif
}


void UpdateMODE()
{
 ScreenPutString(tMODE[MODE],CMode,0,0);
 ScreenPutString("",CBorder,7,0);
}

#ifdef MODULE

#include "dasm.c"
#include "regs.c"
#include "label.c"
#include "list.c"
#include "dump.c"
#include "help.c"

void CopyCPUData()
{
 RegOld=RR;

 RR.af   =TblData->DataCPU.RegAF;
 RR.bc   =TblData->DataCPU.RegBC;
 RR.de   =TblData->DataCPU.RegDE;
 RR.hl   =TblData->DataCPU.RegHL;
 RR.ix   =TblData->DataCPU.RegIX;
 RR.iy   =TblData->DataCPU.RegIY;
 RR.afa  =TblData->DataCPU.RegAFa;
 RR.bca  =TblData->DataCPU.RegBCa;
 RR.dea  =TblData->DataCPU.RegDEa;
 RR.hla  =TblData->DataCPU.RegHLa;
 RR.r    =TblData->DataCPU.RegR;
 RR.i    =TblData->DataCPU.RegI;
 RR.pc   =TblData->DataCPU.RegPC;
 RR.sp   =TblData->DataCPU.RegSP;
 RR.p7ffd=TblData->Port7FFD;
 RR.i1   =TblData->DataCPU.IFF1;
 RR.i2   =TblData->DataCPU.IFF2;
 RR.Timer=TblData->TimerRate;

 AddrLIST=RR.pc;
}
#endif


void UpdateTXT()
{
 ScreenPutString(" DBG 0.02 by Sergey Erokhin aka ESL, 2:461/108.7, Kharkov, Ukraine      ",CText  ,8,0);
}

void UpdateScreen(void)
{
 ScreenPutString("",CBorder,0,1);
 ScreenPutString("",CBorder,0,16);
 ScreenPutString("7f",CRegs,71,14);
 UpdateMODE();
 UpdateTXT();
 UpdateLIST();
 UpdateREGS();
 UpdateDUMP();
}

void doMODE()
{
 MODE=mMODE;UpdateMODE();
 while (MODE == mMODE)
   {
    switch (getxkey())
      {
       case K_Escape:
       case 'h':
       case 'H': {Help();break;};
       case 'l':
       case 'L': {MODE=mLIST;break;};
       case 'd':
       case 'D': {MODE=mDUMP;break;};
       case 'r':
       case 'R': {MODE=mREGS;break;};
       case 'q':
       case 'Q': {MODE=mEXIT;break;};
      }
   }
}

#ifdef MODULE

#define cTRACE 1
#define cMENU  2

void Dmain(int cType)
{
#else
int main(void)
{
 char str[1024];

 int  addr=0;
 int  len;
 int  i;

 RAM[0xffff]=0xcd;
 RAM[0xf54f]=0x10;
 RAM[0xf550]=0xfe;
 RR.pc=0xd;
 RegOld.pc=0x0;

 AddLabel(0,"Hello" );
 AddLabel(0xc3,"Hello1");
 AddLabel(2,"Hello2");

 ScreenClear();

 AddrLIST=0x0;
 AddrDUMP=0;

#endif

 MODE=0; // List

#ifdef MODULE
 if (TraceCPU) {TblData->CPUTraceOff(Id);}
#endif
 TraceCPU=0;
 while (MODE != mEXIT)
  {
   UpdateScreen();
   switch (MODE)
      {
       case mLIST: {doLIST();break;}
       case mDUMP: {doDUMP();break;}
       case mREGS: {doREGS();break;}
      }
    if (!TraceCPU) doMODE();
#ifdef MODULE
    else {MODE=mEXIT;TblData->CPUTraceOn(Id);}
#endif
  }
}






