/*
   my library for ZD80
*/
#include "my.h"

char HEX[]="0123456789abcdef";


char *PutWORD(char *str,word W)
{
  char *ptr=str;
  *ptr++= HEX[(W & 0xf000) >> 12];
  *ptr++= HEX[(W & 0x0f00) >>  8];
  *ptr++= HEX[(W & 0x00f0) >>  4];
  *ptr++= HEX[(W & 0x000f)];
  *ptr='\0';
  return ptr;
}

char *PutBYTE(char *str,byte B)
{
  char *ptr=str;
  *ptr++= HEX[(B & 0x00f0) >>  4];
  *ptr++= HEX[(B & 0x000f)];
  *ptr='\0';
  return ptr;
}

char *PutCHAR(char *str,char C)
{
  char *ptr=str;
  *ptr++=C;
  *ptr='\0';
  return ptr;
}

char *PutSTR(char *str,char *src)
{
  char *ptr=str;
  while (*src) *ptr++=*src++;
  *ptr='\0';
  return ptr;
}

int _memcmp(char *s1, char *s2, int n)
{
  char *p1 = s1, *p2 = s2;
  if (n != 0)
  {

    do {
      if (*p1++ != *p2++)
	return (*--p1 - *--p2);
    } while (--n != 0);
  }
  return 0;
}

char *_strcat(char *s, const char *append)
{
  char *save = s;

  for (; *s; ++s);
  while ((*s++ = *append++));
  return save;
}

char *_strchr(const char *s, int c)
{
  char cc = c;
  while (*s)
  {
    if (*s == cc)
      return (char *)s;
    s++;
  }
  if (cc == 0)
    return (char *)s;
  return 0;
}

int _strcmp(const char *s1, const char *s2)
{
  while (*s1 == *s2)
  {
    if (*s1 == 0)
      return 0;
    s1++;
    s2++;
  }
  return *(unsigned const char *)s1 - *(unsigned const char *)(s2);
}

char *_strcpy(char *to, const char *from)
{
  char *save = to;

  for (; (*to = *from); ++from, ++to);
  return save;
}

int _strcspn(const char *s1, const char *s2)
{
  const char *p, *spanp;
  char c, sc;

  for (p = s1;;)
  {
    c = *p++;
    spanp = s2;
    do {
      if ((sc = *spanp++) == c)
	return p - 1 - s1;
    } while (sc != 0);
  }
  /* NOTREACHED */
}

int _strlen(const char *str)
{
  const char *s;

  if (str == 0)
    return 0;
  for (s = str; *s; ++s);
  return s-str;
}

char *_strncat(char *dst, const char *src, int n)
{
  if (n != 0)
  {
    char *d = dst;
    const char *s = src;

    while (*d != 0)
      d++;
    do {
      if ((*d = *s++) == 0)
	break;
      d++;
    } while (--n != 0);
    *d = 0;
  }
  return dst;
}

int _strncmp(const char *s1, const char *s2, int n)
{

  if (n == 0)
    return 0;
  do {
    if (*s1 != *s2++)
      return *(unsigned const char *)s1 - *(unsigned const char *)--s2;
    if (*s1++ == 0)
      break;
  } while (--n != 0);
  return 0;
}

char *_strncpy(char *dst, const char *src, int n)
{
  if (n != 0) {
    char *d = dst;
    const char *s = src;

    do {
      if ((*d++ = *s++) == 0)
      {
	while (--n != 0)
	  *d++ = 0;
	break;
      }
    } while (--n != 0);
  }
  return dst;
}

char *_strrchr(const char *s, int c)
{
  char cc = c;
  const char *sp=(char *)0;
  while (*s)
  {
    if (*s == cc)
      sp = s;
    s++;
  }
  if (cc == 0)
    sp = s;
  return (char *)sp;
}

char *_strstr(const char *s, const char *find)
{
  char c, sc;
  int len;

  if ((c = *find++) != 0)
  {
    len = _strlen(find);
    do {
      do {
	if ((sc = *s++) == 0)
	  return 0;
      } while (sc != c);
    } while (_strncmp(s, find, len) != 0);
    s--;
  }
  return (char *)s;
}

#ifdef MODULE

unsigned ScreenPutString(char *txt,int color,int x,int y);
#pragma aux ScreenPutString=\
    "   imul ax,ax,0xa0"\
    "   add eax,0x0b8000"\
    "   add eax,ecx"\
    "   add eax,ecx"\
    "   mov edi,eax"\
    "   mov ah,bl"\
    "m1:"\
    "   lodsb"\
    "   or al,al"\
    "   jz m2"\
    "   stosw"\
    "   jmp m1"\
    "m2:"\
  modify [eax edi ecx] parm [esi] [ebx] [ecx] [eax]

unsigned ClearScreen();
#pragma aux ClearScreen=\
    "   mov edi,0x0b8000"\
    "   mov eax,0x0f20"\
    "   mov ecx,2000"\
    "   repe stosw"\
  modify [eax edi ecx]
//
unsigned int getxkey();
#pragma aux getxkey=\
    "   mov ah,0x10"\
    "   int 0x16"\
    "   xor ebx,ebx"\
    "   mov bl,ah"\
    "   cmp al,0"\
    "   jnz m1"\
    "   mov bh,0x01"\
    "   jmp m3"\
    "m1:"\
    "   cmp al,0xe0"\
    "   jnz m2"\
    "   mov bh,0x02"\
    "   jmp m3"\
    "m2:"\
    "   mov bl,al"\
    "m3:"\
  modify [eax ebx ecx edi esi] value [ebx]


#endif

word EditWORD(word W,int x,int y)
{
 word tW=W;
 char CW[5]="0000";
 char W1[2]="0";
 int  CX=0;
 int  Key;
 int  AND  [4]={0x0fff,0xf0ff,0xff0f,0xfff0};
 int  SHIFT[4]={12,8,4,0};

 for (;;)
    {
     PutWORD(CW,tW);ScreenPutString(CW,0x0f,x,y);
     W1[0]=CW[CX];ScreenPutString(W1,0x70,x+CX,y);

     switch (Key=getxkey())
       {
        case '0': case '1': case '2': case '3': case '4': case '5':
        case '6': case '7': case '8': case '9': case 'a': case 'A':
        case 'b': case 'B': case 'c': case 'C': case 'd': case 'D':
        case 'e': case 'E': case 'f':
        case 'F':
             {
              Key|=0x20;
              Key=_strchr(HEX,Key)-HEX;
              tW&=AND[CX];
              tW|=Key<<SHIFT[CX];
              //break;
             }
        case K_Right :
        case K_ERight: { if (CX<3) CX++;break;};

        case K_Return: {return tW;}
        case K_Escape: {return W;}

        case K_Left  :
        case K_ELeft : { if (CX) CX--;break;};

       }
    }
}

int GetBYTE(byte B,int x,int y)
{
 byte tB=B;
 char CB[3]="00";
 char B1[2]="0";
 int  CX=0;
 int  Key;
 int  AND  [2]={0x0f,0xf0};
 int  SHIFT[2]={4,0};

 for(;;)
    {
     PutBYTE(CB,tB);ScreenPutString(CB,0x0f,x,y);
     B1[0]=CB[CX];ScreenPutString(B1,0x70,x+CX,y);
     switch (Key=getxkey())
       {
        case '0': case '1': case '2': case '3': case '4': case '5':
        case '6': case '7': case '8': case '9': case 'a': case 'A':
        case 'b': case 'B': case 'c': case 'C': case 'd': case 'D':
        case 'e': case 'E': case 'f':
        case 'F':
             {
              Key|=0x20;
              Key=_strchr(HEX,Key)-HEX;
              tB&=AND[CX];
              tB|=Key<<SHIFT[CX];
              if (CX == 1) return tB;
             }
        case K_Right :
        case K_ERight: { if (CX<1) CX++; else return tB;break;};

        case K_Return: {return tB;}
        case K_Escape: {return -(B+1);}

        case K_Left  :
        case K_ELeft : { if (CX) CX--;else return -K_Left;break;};

       }
    }
}



