#include "my.h"

extern CBorder;
extern CRegs;
extern CRegs2;
extern CRegs3;

typedef struct
{
  int *Addr;
  int Type; // 0-AF,1-HL00,2-HL"",3-SP,4-00,5-0
  char *Name;
  int x;
  int y;
} _Regs;

#ifndef MODULE
_CPUReg RR;

_CPUReg RegOld;
#endif

char RegBUF[128];

void PutAF(_Regs *R)
{
// char Flag[]="sz0h0pnc";
// char Flag[]="        ";
 char Flag[]="........";
 word af=*(R->Addr) & 0xffff;
 int fl=af & 0xff;
 char *buf=RegBUF;

 if (fl & 0x80) Flag[0]='S';
 if (fl & 0x40) Flag[1]='Z';
 if (fl & 0x20) Flag[2]='5';
 if (fl & 0x10) Flag[3]='H';
 if (fl & 0x08) Flag[4]='3';
 if (fl & 0x04) Flag[5]='P';
 if (fl & 0x02) Flag[6]='N';
 if (fl & 0x01) Flag[7]='C';

// sprintf(buf,"%s%04X '%c'%s",R->Name,af,AIF((af&0xff00)>>8),Flag);
 buf=PutSTR(buf,R->Name);buf=PutWORD(buf,af);buf=PutSTR(buf," '");
 buf=PutCHAR(buf,AIF((af&0xff00)>>8));buf=PutCHAR(buf,'\'');PutSTR(buf,Flag);
}

void PutHLDmp(_Regs *R)
{
 word a=*(R->Addr) & 0xffff;
 char *buf=RegBUF;
// sprintf(buf,"%s%04X %02x %02x %02x %02x",R->Name,a,RdZ80(a),RdZ80(a+1),RdZ80(a+2),RdZ80(a+3));
 buf=PutSTR(buf,R->Name);buf=PutWORD(buf,a);buf=PutSTR(buf," ");
 buf=PutBYTE(buf,RdZ80(a+0));buf=PutSTR(buf," ");
 buf=PutBYTE(buf,RdZ80(a+1));buf=PutSTR(buf," ");
 buf=PutBYTE(buf,RdZ80(a+2));buf=PutSTR(buf," ");
 buf=PutBYTE(buf,RdZ80(a+3));buf=PutSTR(buf," ");
}

void PutSP(_Regs *R)
{
 word a=*(R->Addr) & 0xffff;
 char *buf=RegBUF;

 word w1=RdZ80(a)+256*RdZ80(a+1);
 word w2=RdZ80(a+2)+256*RdZ80(a+3);

//sprintf(buf,"%s%04X %04x %04x",R->Name,a,w1,w2);
 buf=PutSTR(buf,R->Name);buf=PutWORD(buf,a);buf=PutSTR(buf," ");
 buf=PutWORD(buf,w1);buf=PutSTR(buf," ");
 buf=PutWORD(buf,w2);
}

void PutHLStr(_Regs *R)
{
 word a=*(R->Addr) & 0xffff;
 char *buf=RegBUF;
 char asc[10];
 int i;
 for (i=0;i<9;i++) asc[i]=AIF(RdZ80(a+i));
 asc[9]='\0';
// sprintf(buf,"%s%04X \"%s\"",R->Name,a,asc);
 buf=PutSTR(buf,R->Name);buf=PutWORD(buf,a);buf=PutSTR(buf," \"");
 buf=PutSTR(buf,asc);buf=PutSTR(buf,"\"");
}

void PutB(_Regs *R)
{
 word a=*(R->Addr) & 0xff;
 char *buf=RegBUF;
// sprintf(buf,"%s%02X",R->Name,a);
 buf=PutSTR(buf,R->Name);buf=PutBYTE(buf,a);
}

void PutDig(_Regs *R)
{
 word a=*(R->Addr) & 0xff;
 char *buf=RegBUF;
//sprintf(buf,"%s%1X",R->Name,a&1);
  buf=PutSTR(buf,R->Name);buf=PutCHAR(buf,(a!=0)?'1':'0');
}

void UpdateREGS(void)
{
 int i;
 _CPUReg *pCReg;

 _Regs R[18]={ {&RR.af,0,"AF=",61, 2},{&RR.bc,1,"BC=",61, 3},{&RR.de,2,"DE=",61, 4},{&RR.hl,1,"HL=",61, 5},
               {&RR.ix,1,"IX=",61, 6},{&RR.iy,2,"IY=",61, 7},{&RR.afa,0,"AF'",61, 8},{&RR.bca,1,"BC'",61, 9},
               {&RR.dea,1,"DE'",61,10},{&RR.hla,2,"HL'",61,11},{&RR.pc,1,"PC=",61,12},{&RR.sp,3,"SP=",61,13},
               {&RR.r,4," R=",60,14},{&RR.i,4," I=",65,14},{&RR.p7ffd,4,"FD=",73,14},{&RR.im,4,"IM=",61,15},
               {&RR.i1,4,"I1=",67,15},{&RR.i2,4,"I2=",73,15}
             };

 _Regs R1[18]={ {&RegOld.af,0,"AF=",61, 2},{&RegOld.bc,1,"BC=",61, 3},{&RegOld.de,2,"DE=",61, 4},{&RegOld.hl,1,"HL=",61, 5},
               {&RegOld.ix,1,"IX=",61, 6},{&RegOld.iy,2,"IY=",61, 7},{&RegOld.afa,0,"AF'",61, 8},{&RegOld.bca,1,"BC'",61, 9},
               {&RegOld.dea,1,"DE'",61,10},{&RegOld.hla,2,"HL'",61,11},{&RegOld.pc,1,"PC=",61,12},{&RegOld.sp,3,"SP=",61,13},
               {&RegOld.r,4," R=",60,14},{&RegOld.i,4," I=",65,14},{&RegOld.p7ffd,4,"FD=",73,14},{&RegOld.im,5,"IM=",61,15},
               {&RegOld.i1,4,"I1=",67,15},{&RegOld.i2,4,"I2=",73,15}
             };

 for (i=0;i<18;i++)
    {
     *RegBUF='\0';
     switch (R[i].Type)
       {
        case 0: {PutAF(&R[i]);break;}
        case 1: {PutHLDmp(&R[i]);break;}
        case 2: {PutHLStr(&R[i]);break;}
        case 3: {PutSP(&R[i]);break;}
        case 4: {PutB(&R[i]);break;}
        case 5: {PutDig(&R[i]);break;}
       }
     ScreenPutString(RegBUF,CRegs,R[i].x,R[i].y);

      *RegBUF='\0';
     if ( (*(R[i].Addr) != *(R1[i].Addr)))
     {
      if (i<12) PutWORD(RegBUF,*(R[i].Addr));
      else if ( i<16 ) PutBYTE(RegBUF,*(R[i].Addr));
      ScreenPutString(RegBUF,CRegs3,R[i].x+3,R[i].y);
     }
    }
/*
    PutWORD(RegBUF,RR.Timer & 0xffff);
    ScreenPutString(RegBUF,CRegs,80-4,0);
    PutWORD(RegBUF,(RR.Timer&0xffff0000)>>16);
    ScreenPutString(RegBUF,CRegs,80-8,0);
*/
}

void doREGS()
{
 getxkey();
}
